#include <common/multitasking.h>
#include <drivers/io.h>

Task::Task(GlobalDescriptorTable* gdt, void entrypoint()){
    cpustate = (CPUState*)(stack + 4096 - sizeof(CPUState));

    cpustate->eax    = 0;
    cpustate->ebx    = 0;
    cpustate->ecx    = 0;
    cpustate->edx    = 0;

    cpustate->esi    = 0;
    cpustate->edi    = 0;
    cpustate->ebp    = 0;

    // cpustate->gs  = 0;
    // cpustate->fs  = 0;
    // cpustate->es  = 0;
    // cpustate->ds  = 0;

    // cpustate->error=0;
    
    // cpustate->esp = 
    cpustate->eip    = (uint32_t)entrypoint;
    cpustate->cs     = gdt->CodeSegmentSelector();
    // cpustate->ss  = 
    cpustate->eflags = 0x202;
    return;
}

Task::~Task(){
    return;
}

TaskManager::TaskManager(){
    numTask = 0;
    curTask = -1;
    printf("[INFO] TaskManager Loaded.\n");
    return;
}
    
TaskManager::~TaskManager(){
    return;
}
    
bool TaskManager::AddTask(Task* task){
    if(numTask >= 256)
        return false;
    tasks[numTask] = task;
    numTask ++;
    return true;
}
    
CPUState* TaskManager::Schedule(CPUState* cpustate){
    if(numTask <= 0)
        return cpustate;

    if(curTask >= 0)
        tasks[curTask]->cpustate = cpustate;

    if(++ curTask >= numTask)
        curTask %= numTask;
    
    return tasks[curTask]->cpustate;
}